#include        <sys/transp.h>
#include        <sys/crt.h>

#define H1_START_VCP_REGISTER_ADDRESS  0x0804
#define H1_MEMSTART_ADDRESS             0x410e
#define H1_VCP_MININVALID_CHAN_REGISTER_ADDRESS 0x010f
#define H1_VCP_LINK_HEADER_UPPER_LIMIT_ADDRESS	0x0806
#define H1_VCP_LINK_HEADER_LOWER_LIMIT_ADDRESS	0x0807
#define H1_VCP_LINK_HEADER_OFFSET_ADDRESS	0x0808
#define H1_VCP_LINK_MODE_ADDRESS	0x0805
#define H1_HEADER_BASE_AREA_ADDRESS	0x0901
#define H1_EXTERNAL_RC_BASE_ADDRESS	0x4110




.text
.globl _SwitchVcpState
_SwitchVcpState:
        ldl     SYS_fnent_argptr
        ldnl    0
        ldc H1_START_VCP_REGISTER_ADDRESS
        stconf
        nop
	ret

.globl _SetMemStart
_SetMemStart:
        ldl     SYS_fnent_argptr
        ldnl    0
        ldc H1_MEMSTART_ADDRESS
        stconf
        nop
	ret
.globl _SetMinInvalidChannelRegister
_SetMinInvalidChannelRegister:
        ldl     SYS_fnent_argptr
        ldnl    0
        ldc H1_VCP_MININVALID_CHAN_REGISTER_ADDRESS
        stconf
        nop
	ret

.globl _InitializeVLCBAndBufferPointer
_InitializeVLCBAndBufferPointer:
        ldl     SYS_fnent_argptr
        ldnl    1
        ldl     SYS_fnent_argptr
        ldnl    0
        initvlcb
	ret

.globl _SetHeaderInVLCB
_SetHeaderInVLCB:
        ldl     SYS_fnent_argptr
        ldnl    2
        ldc 0xffff
        and
        ldl     SYS_fnent_argptr
        ldnl    1
        ldl     SYS_fnent_argptr
        ldnl    0
        sethdr
	ret

.globl _WriteHeaderInVLCB
_WriteHeaderInVLCB:
        ldl     SYS_fnent_argptr
        ldnl    2
        ldl     SYS_fnent_argptr
        ldnl    1
        ldl     SYS_fnent_argptr
        ldnl    0
        writehdr
	ret

.globl _SetChannelMode
_SetChannelMode:
        ldl     SYS_fnent_argptr
        ldnl    1
        ldl     SYS_fnent_argptr
        ldnl    0
        setchmode
        nop
	ret


.globl _UpdateHeaderForLink
_UpdateHeaderForLink:
        ldl     SYS_fnent_argptr
        ldnl    3
	ldc	0xffff
	and
        ldl     SYS_fnent_argptr
        ldnl    7
	stconf
	nop
	
        ldl     SYS_fnent_argptr
        ldnl    2
	ldc	0xffff
	and
        ldl     SYS_fnent_argptr
        ldnl    6
	stconf
	nop

	ldl     SYS_fnent_argptr
        ldnl    0
	ldc	0xffff
	and
        ldl     SYS_fnent_argptr
        ldnl    4
	stconf
	nop

	ldl     SYS_fnent_argptr
        ldnl    1
	ldc	0xffff
	and
        ldl     SYS_fnent_argptr
        ldnl    5
	stconf
	nop

	ret

.globl _SetExternalRCBaseAddress
_SetExternalRCBaseAddress:
	ldl     SYS_fnent_argptr
        ldnl    0
	ldc	H1_EXTERNAL_RC_BASE_ADDRESS
	stconf
	nop
	ret


.globl _SetHeaderBaseAreaReg
_SetHeaderBaseAreaReg:
	ldl     SYS_fnent_argptr
        ldnl    0
	ldc	H1_HEADER_BASE_AREA_ADDRESS
	stconf
	nop
	ret


