#include <conc.h>
#include <node.h>

extern int server_transaction(unsigned char *, int, unsigned char *);

static enum {
#if 0
	SpBuffSize=512,
#else
	SpBuffSize=1040,
#endif
	EnvSize=500,
	NoEnv=4
};
static enum {
	SpExit=35,
	SpCommand=40
};


#define PACK_ITEM(x,y,c) { char *n=(char *)&(x); int i; \
        for(i=0;i<sizeof(x);i++) (y)[c++]=*(n++); }
#define PACK_SLICE(x,l,y,c) (y)[c++]=(l)&255; (y)[c++]=((l)>>8)&255; \
                            memcpy((y)+c,(x),l); c+=l;
#define UNPACK_ITEM(x,y,c) { char *n=(char *)&(x); int i; \
        for(i=0;i<sizeof(x);i++) *(n++)=(y)[c++]; }
#define UNPACK_SLICE(x,l,y,c) (l)=(y)[c++]; (l)+=((y)[c++])<<8; \
                              memcpy((x),(y)+c,l); c+=l;

static unsigned char Send[SpBuffSize],Recv[SpBuffSize];

/*{{{  GetArgs()*/
#define SWITCH_CHAR	'-'
void ParseCommandLine ( char *CommandLine )
{
	register unsigned char *s, *t, *str;
	int i;
	int Gobble=1;

	t = (char *)CommandLine;
	str = (unsigned char *)malloc( (strlen(CommandLine)+1)*sizeof(unsigned char) );
	s = str;
	strcpy( s, CommandLine );
	*t= '\0';
	while( (*s) && (*s != ' ') )
		++s;
	if ( *s == ' ' )
		++s;
	for(;;)
	{
		if ( *s == '\0' ){
			*t = '\0';
			free(str);
			return;
		}
		if (  (*s==SWITCH_CHAR) && ( (*(s+1)=='s') || (*(s+1)=='S') )  )
		{
			s += 2;
			switch ( *s )
			{
			case 'b' :
			case 'B' :
				++s;
				while( *s == ' ' )
					++s;
				i = 0;
				while( (*s) && (*s != SWITCH_CHAR) && (*s != ' ') )
					*t++ = *s++;
				*t++ = ' ';
				break;
			case 'c' :
			case 'C' :
				++s;
				while( *s == ' ' )
					++s;
				while( (*s) && ( (*s!=SWITCH_CHAR) && (*s!=' ') ) )
					s++;
				break;
			case 'l' :
			case 'L' :  
				++s;
				while( *s == ' ' )
					++s;
				while( (*s) && ( (*s!=SWITCH_CHAR) && (*s!=' ') ) )
					s++;
				break;

			case 'p' :
			case 'P' :  
				++s;
				while (*s == ' ')
					++s;
				while( (*s) && (*s!=SWITCH_CHAR) )
					++s;
				break;
			case 'a' :
			case 'A' :  
			case 'e' :
			case 'E' :  
			case 'i' :
			case 'I' :  
			case 'r' :
			case 'R' :  
			case 's' :
			case 'S' :  
			case 'z' :
			case 'Z' :  
				if (( *(s+1) == ' ')||( *(s+1) == '\t')||(*(s+1)== '\n')||(*(s+1)== '\0')){
					++s; 
					break;
				}
			default  :
				*t++ = SWITCH_CHAR;
				*t++ = *(s-1);
				Gobble = 0;
				break;
			}
			if ( (Gobble) && (*s == ' ') )
				++s;
		}
		else
		{
			if (  (*s==SWITCH_CHAR) && ( (*(s+1)=='p') || (*(s+1)=='P') )  )
			{
				int i=0;
				s+=2; /* skip -P or -p */
				while (*s==' ') s++;
				while ( (*s) && ( ( *s!=SWITCH_CHAR)  && (*s!=' ') ) )
					s++;

			}
			else
			{
				*t++ = *s++;
			}
		}
	}
	free( str );
}
int GetArgs( char *str )
{
	int rc, c, Len, OutSigio, NewErrno;

	/*{{{  Fill send buffer*/
	c=0;
	Send[c++]=SpCommand;
	Send[c++]=1;
	c=(c+1) & (~1);
	c = (c < 8)?8:0;
	/*}}}*/
	if ((Len=server_transaction(Send,c,Recv))<0)
	{ 
		return(-1); 
	}
	c=0;
	rc=Recv[c++];
	/*
  if ( rc != 0 )return( 0 );
  */
	UNPACK_SLICE( str,Len, Recv, c );
	str[Len] = '\0';
	ParseCommandLine(str);
	return(Len);
}
/*}}}*/


/*{{{  server_transaction*/

int server_transaction( unsigned char *Send, int len, unsigned char *Recv )
{
	unsigned short size = len;

	__semp( &_Node.serversem );
	VChanOut( _Node.toserver, Send, size );
	size = VChanIn( _Node.fromserver, Recv, SpBuffSize );
	__semv( &_Node.serversem );
	return size;
}
/*}}}*/

__Exit(int retval)
{
	int rc, c, Len;

	/*{{{  Fill send buffer*/
	c=0;
	Send[c++]=SpExit;
	if ( retval == 0 )retval = 999999999;
	else retval = -999999999;
	PACK_ITEM(retval,Send,c);
	c=(c+1) & (~1);
	c = (c < 8)?8:0;
	/*}}}*/
	if ((Len=server_transaction(Send,c,Recv))<0)
	{ 
		return(-1); 
	}
	return(0);
}

