.so man.macros
.HS vcpsend tk 
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
vcpxfer \- Send  messages over a virtual channel and receive the reply messages.
.SH SYNOPSIS
\fBvcpxfer \fIsendchan  sendackhan recvchan recvackchan\fR ?\fIoptions\fR?
.BE

.SH OPTIONS
.IP "\fB\-data \fIdata\fR" 15
Data is provided in the Tcl variable \fIdata\fR in the form of a string. The
format for specifying data is \fIelement\fR?.\fIelement\fR.\fI ... element\fR? .
Each element in this string is assumed to be 32\-bit if it ends in the
character l, 16\-bit if it ends in s, and 8\-bit otherwise. 
Hexadecimal numbers should be preceded by 0x and octal numbers by the
digit 0.
Each message is terminated by the token \fI.r\fR .
.IP "\fB\-timeout \fItime command\fR" 15
If the messages cannot be transferred in the number of microseconds specified by
\fItime\fR, abort the command and execute the Tcl/Tk command specified
by \fIcommand\fR.

.SH DESCRIPTION
.PP
This command is used to transfer a list of messages over a virtual channel.
The reply for each message is received and ignored.
\fIsendchan\fR specifies the virtual channel address of the destination. It is
of the form \fIlink\fR.\fIsubheader\fR?.\fIsubheader ...\fR? . Each of the
subheaders is a decimal number, and is assumed to be a two\-byte header,
if its value is greater than 255 or if it starts with a zero. Otherwise, it
is assumed to be a single\-byte header. \fIlink\fR can take values
l0, l1, l2 and l3.  \fIsendackchan\fR specifies the virtual
channel address where the acknowledgement is expected. It has the format
?\fIlink\fR.?\fIsubheader\fR . \fIrecvchan\fR specifies the virtual channel
address where the reply is expected, and has the same format as \fIsendackchan\fR.
\fIrecvackchan\fR is the virtual channel address to which the acknowledgement
of the reply message is sent, and has the same format as \fIsendchan\fR.

The message is packetized and sent in
the format required by C100. The command is complete when all the messages
have been sent and their replies received.  Virtual VCP should be
initialized by running \fIvcpinit\fR on \fIlink\fR before this call is made.
.SH SEE ALSO
run, vcpsend, vcprecv
