#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <netdb.h>
#include <errno.h>
#include <conc.h>
#include "tcl.h"
#include "tclInt.h"

#define HOST_NAME	"tcl_hostname"
#define PORT_NUMBER	"tcl_portnumber"
#define QLEN		10

/*
 * The following structure defines all of the commands supported by
 * VCP, and the C procedures that execute them.
 */

typedef struct {
    char *name;			/* Name of command. */
    int (*cmdProc) _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
	    int argc, char **argv));
				/* Command procedure. */
} VcpCmd;


VcpCmd VcpCommands[] = {
    /*
     * Commands that are part of the intrinsics:
     */

    {"run",		Tcl_RunCmd},
    {"vcpsend",		Tcl_SendCmd},
    {"vcprecv",		Tcl_RecvCmd},
    {"inspect",		Tcl_InspectCmd},
    {"vcpxfer",		Tcl_XferCmd},
    {(char *) NULL,	(int (*)()) NULL}

};

Vcp_Init( Tcl_Interp *interp )
{
    /*
     * Bind in VCP's commands.
     */
    VcpCmd *cmdPtr;
    Process *TclProc;

    for (cmdPtr = VcpCommands; cmdPtr->name != NULL; cmdPtr++) {
	Tcl_CreateCommand(interp, cmdPtr->name, cmdPtr->cmdProc,
		(ClientData) 0, (void (*)()) NULL);
    }
    SetServerSemaphore(); /* Semaphore used by VCP and iserver */
}
