/*	Definitions used by TCL
*/

#ifndef TCL_VCP_DEFS_H
#define TCL_VCP_DEFS_H

/*	Character used to separate the headers 
*/
#define ADDRESS_SEPARATOR		'.'

/*	Character used to separate bytes when specifying binary data
*/
#define	DATA_SEPARATOR			'.'

/*	Character used to specify end of message
*/
#define MESSAGE_SEPARATOR		'r'

/*	Characters used to specify data length for messages
*/
#define LONG_WORD_SPEC			'l'
#define SHORT_WORD_SPEC			's'
#define MAX_MESSAGE_ELEMENT_LEN		12

/*	Radix used for headers
*/
#define	HEADER_RADIX			10

/*	No. of characters used to specify a byte in hexadecimal
*/
#define LENGTH_PER_BYTE			5

/*	Maximum value or a header ( Maximum 16 bit number )
*/
#define	MAX_HEADER_VALUE		65535

/*	Character used to specify a parameter to a command
*/
#define PARAMETER_SPEC_CHAR		'%'

/*	Parameters to commands filled by run
*/
#define	HOST_NAME			"host"
#define PORT_NUMBER			"port"

/*	Maximum length of a Unix system command passed to TCL 
*/
#define MAX_UNIX_COMMAND_LEN		256


/*	Options for TCL commands
*/
#define	DATA_OPTION			"-data"
#define	FILE_OPTION			"-file"
#define	BIND_OPTION			"-bind"
#define	TIMEOUT_OPTION			"-timeout"
#define	WINDOW_OPTION			"-window"

/*	Functions that can be invoked using run
*/
#define	VCP_INIT	"#vcpinit"
#define	VCP_QUIT	"#vcpquit"
#define SERV_INIT	"#servinit"
#define SERV_QUIT	"#servquit"
#define COFF_SERV_INIT	"#coffserver"
#define LOCAL_WRITE	"#localwrite"

#endif
